<?php 
class WCEV_OptionPage
{
	public function __construct()
	{
		$this->init_options_menu();
	}
	function init_options_menu()
	{
		if( function_exists('acf_add_options_page') ) 
		{
			
			
			 acf_add_options_sub_page(array(
				'page_title' 	=> esc_html__('EU Vat field - Options', 'woocommerce-eu-vat-field'),
				'menu_title'	=> esc_html__('EU Vat field - Options', 'woocommerce-eu-vat-field'),
				'parent_slug'	=> 'woocommerce',
				'capability' => 'manage_woocommerce'
			));
			
			
			
			add_action( 'current_screen', array(&$this, 'cl_set_global_options_pages') );
		}
	}
	/**
	 * Force ACF to use only the default language on some options pages
	 */
	function cl_set_global_options_pages($current_screen) 
	{
	  if(!is_admin())
		  return;
	  
	
	  
	  $page_ids = array(
		"wcev_ticket_page_acf-options-ticket-system-options"
	  );
	
	  if (in_array($current_screen->id, $page_ids)) 
	  {
		global $wcev_wpml_helper;
		$wcev_wpml_helper->switch_to_default_language();
		add_filter('acf/settings/current_language', array(&$this, 'cl_acf_set_language'), 100);
	  }
	}
	

	function cl_acf_set_language() 
	{
	  return acf_get_setting('default_language');
	}

	
}
?>