<?php 
	class WCEV_OrderDetailsPage
	{
		public function __construct()
		{
			add_action( 'woocommerce_admin_order_data_after_order_details',  array( &$this,'display_custom_data' ));
			add_filter( 'woocommerce_admin_billing_fields',  array( &$this,'add_eu_vat_field_to_order_details_fields' )); //admin order details page
			
			//Field save (forced)
			//add_action( 'woocommerce_process_shop_order_meta', array( &$this, 'woocommerce_process_shop_ordermeta' ), 5, 2 );
		}
	
		public function display_vat_on_admin_order_details_page( $order ) 
		{
			global $wcev_order_model, $wcev_text_helper;
			$texts = $wcev_text_helper->get_texts();
			$business_or_consumer = $wcev_order_model->get_client_type(WCEV_Order::get_id($order));
			$business_or_consumer_result =  $business_or_consumer && $business_or_consumer == 'consumer' ? $texts['consumer_option_label'] : $texts['business_option_label'];
			

		}
		public function display_custom_data( $order ) 
		{
			global $wcev_order_model, $wcev_text_helper,$wcev_vat_field_model;
			if(!$order)
				return;
			$texts = $wcev_text_helper->get_texts();
			$business_or_consumer = $wcev_order_model->get_client_type(WCEV_Order::get_id($order));
			$business_or_consumer_result =  $business_or_consumer && $business_or_consumer == 'consumer' ? $texts['consumer_option_label'] : $texts['business_option_label'];
			$was_invoice_requested = $invoice_was_requested = $wcev_order_model->was_invoice_requested(WCEV_Order::get_id($order)) ? esc_html__( 'Yes', 'woocommerce-eu-vat-field' ) : esc_html__( 'No', 'woocommerce-eu-vat-field' );
			$render_note = false;
			
			if($business_or_consumer && $wcev_vat_field_model->get_all_options('show_business_consumer_selector', false))
			{
				$render_note = true;
				echo "<p class='form-field form-field-wide' style='margint-top: 20px; display:block;'><strong>".esc_html__('Customer type', 'woocommerce-eu-vat-field').": </strong><br/>" .$business_or_consumer_result . "</p>";
			}
			if($was_invoice_requested && $wcev_vat_field_model->get_all_options('show_require_invoice_option', false))
			{
				echo '<p class="form-field form-field-wide"><strong>'.esc_html__('Invoice requested', 'woocommerce-eu-vat-field').': </strong><strong>' .$was_invoice_requested . '</strong></p>';
				$render_note = true;
			}	
			if( $render_note)
				echo ' <small>('.wcev_html_escape_allowing_special_tags(__( 'To modify these values: edit the <strong>Billing Details</strong>', 'woocommerce-eu-vat-field' ),false).')</small>';
		}
		public function woocommerce_process_shop_ordermeta($post_id, $post)
		{
			$order_id = wcev_get_value_if_set($_POST, "ID", false);
			if(!$order_id)
				return;
			$wc_order = wc_get_order($order_id);
			$fields = $this->add_eu_vat_field_to_order_details_fields(array(), $wc_order);
			/* foreach($fields as $field_name => $field)
			{
				$current_field_name = "billing_".$field_name;
				$value = wcev_get_value_if_set($_POST, $current_field_name, "none");
				if($value != "none")
					$wc_order->update_meta_data($current_field_name, $value)
			}
			$wc_order->save(); */
		}
		public function add_eu_vat_field_to_order_details_fields($fields, $wc_order = null)
		{
			global $wcev_order_model, $post, $wcev_text_helper, $wcev_vat_field_model, $theorder;
			$current_order = $wc_order ? $wc_order : $theorder;
			
			
			if(!$post && !$current_order)
				return $fields;
			
			
			$order_id = $post ? $post->ID : $current_order->get_id();
			
			$texts = $wcev_text_helper->get_texts();
			$order = wc_get_order( $order_id);
			wp_enqueue_style('wcev-order-details', WCEV_PLUGIN_PATH.'/css/admin-order-details-page.css');
			wp_enqueue_script('wcev-order-details', WCEV_PLUGIN_PATH.'/js/admin-order-details-page.js', array('jquery'));
			$eu_vat_number = $wcev_order_model->get_vat_number(WCEV_Order::get_id($order));
			$business_or_consumer = $wcev_order_model->get_client_type(WCEV_Order::get_id($order));
			$was_invoice_requested = $wcev_order_model->was_invoice_requested(WCEV_Order::get_id($order));
			$it_sid_pec = $wcev_order_model->get_it_sid_pec(WCEV_Order::get_id($order));
			$es_nif_nie = $wcev_order_model->get_billing_es_nif_nie(WCEV_Order::get_id($order));
			$gr_tax_office = $wcev_order_model->get_billing_gr_tax_office(WCEV_Order::get_id($order));
			$gr_business_activity = $wcev_order_model->get_billing_gr_business_activity(WCEV_Order::get_id($order));
			$cz_company_id = $wcev_order_model->get_billing_cz_company_id(WCEV_Order::get_id($order));
			$sk_company_id = $wcev_order_model->get_billing_sk_company_id(WCEV_Order::get_id($order));
			$sk_company_dic = $wcev_order_model->get_billing_sk_company_dic(WCEV_Order::get_id($order));
			$cod_fiscale = $wcev_order_model->get_codice_fiscale(WCEV_Order::get_id($order));
			$billing_country = $order->get_billing_country();
		
			if($wcev_vat_field_model->get_all_options('show_require_invoice_option', false))
				$fields['request_eu_vat'] = array(
					'label' => esc_html__( 'Requested invoice', 'woocommerce-eu-vat-field' ),
					'show'  =>  false,
					'type' 		=> 'select', //checkbox doens't work
					'options' 	=> array(
										0 => esc_html__( 'No', 'woocommerce-eu-vat-field' ),
										1 => esc_html__( 'Yes', 'woocommerce-eu-vat-field' )
									)
				);
			
			if($wcev_vat_field_model->get_all_options('show_business_consumer_selector', false))
				$fields['business_consumer_selector'] = array(
						'label' => esc_html__( 'Customer type', 'woocommerce-eu-vat-field' ),
						'show'  => false,
						'type' 		=> 'select',
						'options' 	=>  array('consumer' => $texts['consumer_option_label'], 'business' =>$texts['business_option_label'])
					);
			
			$fields['eu_vat'] = array(
				'label' => esc_html__( 'Vat Number', 'woocommerce-eu-vat-field' ),
				'show'  => $eu_vat_number ? true : false
			);
			
			if( $billing_country == 'IT' && $eu_vat_number)
				$fields['it_sid_pec'] = array(
					'label' => esc_html__( 'SDI/Pec', 'woocommerce-eu-vat-field' ),
					'show'  => true ,
					 'value' => $it_sid_pec ? $it_sid_pec : esc_html__( 'N/A', 'woocommerce-eu-vat-field' )
				);
				
			if($billing_country == 'IT' )
				$fields['it_codice_fiscale'] = array(
					'label' => esc_html__( 'Codice fiscale', 'woocommerce-eu-vat-field' ),
					'show'  => true ,
					'value' => $cod_fiscale ? $cod_fiscale : esc_html__( 'N/A', 'woocommerce-eu-vat-field' )
				);
				
			if($billing_country == 'ES')
				$fields['it_codice_fiscale'] = array(
					'label' => esc_html__( 'NIF / NIE', 'woocommerce-eu-vat-field' ),
					'show'  =>  true ,
					'value' => $es_nif_nie ? $es_nif_nie : esc_html__( 'N/A', 'woocommerce-eu-vat-field' )
				);
			
			if($billing_country == 'GR')
						$fields['gr_tax_office'] = array(
								'label' => $texts['gr_tax_office_label'], 
								'value' => wptexturize( $gr_tax_office)
							);
			if( $billing_country == 'GR')
						$fields['gr_business_activity'] = array(
								'label' => $texts['gr_business_activity_label'],
								'value' => wptexturize( $gr_business_activity)
							);	
			if($billing_country == 'CZ')
						$fields['cz_company_id'] = array(
								'label' => $texts['cz_company_id_label'],
								'value' => wptexturize( $cz_company_id)
							);	
			if( $billing_country == 'SK')
						$fields['sk_company_id'] = array(
								'label' => $texts['sk_company_id_label'],
								'value' => wptexturize( $sk_company_id)
							);	
			if( $billing_country == 'SK')
						$fields['sk_company_dic'] = array(
								'label' => $texts['sk_company_dic_label'],
								'value' => wptexturize( $sk_company_dic)
							);	
							
			return $fields;
		}
		
	}	
?>