<?php 
class WCEV_TextCustomizerPage
{
	public function __construct()
	{
		$this->init_options_menu();
	}
	function init_options_menu()
	{
		global $wcev_wpml_helper;
		if( function_exists('acf_add_options_page') ) 
		{
			
			$additional_text = isset($wcev_wpml_helper) && $wcev_wpml_helper->wpml_is_active() ? esc_html__('(To localize text: just switch language using the WPML language selector in the upper admin bar)', 'woocommerce-eu-vat-field') : "";
			 acf_add_options_sub_page(array(
				'page_title' 	=> wcev_html_escape_allowing_special_tags(sprintf(__('EU Vat field - Texts <small>%s</small>', 'woocommerce-eu-vat-field'),$additional_text), false),
				'menu_title'	=> esc_html__('EU Vat field - Texts', 'woocommerce-eu-vat-field'),
				'parent_slug'	=> 'woocommerce',
				'capability' => 'manage_woocommerce'
			));
			add_action( 'current_screen', array(&$this, 'cl_set_global_options_pages') );
		}
	}
	/**
	 * Force ACF to use only the default language on some options pages
	 */
	function cl_set_global_options_pages($current_screen) 
	{
	  if(!is_admin())
		  return;
	  
	  $page_ids = array(
		"woocommerce_page_acf-options-eu-vat-field-texts"
	  );
	 
	  if (in_array($current_screen->id, $page_ids)) 
	  {
		global $wcev_wpml_helper;
		
	  }
	}
	

	function cl_acf_set_language() 
	{
	  return acf_get_setting('default_language');
	}
}
?>